
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_ICP_STATS_H
#define PG_ICP_STATS_H

#include "base/HRStat.h"

class IcpStat {
	public:
		IcpStat();

		void reset();

		bool sane() const;

		void record(const Time &tm, Size sz, bool hit) { theStat.record(tm, sz, hit); }
		void recordTimeout() { theToutCnt++; }

		IcpStat &operator +=(const IcpStat &ts);

		OLog &store(OLog &log) const;
		ILog &load(ILog &log);

		ostream &print(ostream &os, const String &pfx, Time duration) const;

	protected:
		double reqRate(Time duration) const;
		double repRate(Time duration) const;

	protected:
		HRStat theStat;
		int theToutCnt; // number of ICP timeouts
};

inline OLog &operator <<(OLog &ol, const IcpStat &s) { return s.store(ol); }
inline ILog &operator >>(ILog &il, IcpStat &s) { return s.load(il); }

#endif
