
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_SERVER_REPRESENTATIVE_H
#define PG_SERVER_REPRESENTATIVE_H

// client side "representative" of an origin server 
// holds client side knowledge about a server

#include "xstd/NetAddr.h"
#include "base/UniqId.h"

class OLog;
class RepHdr;

class ServerRep {
	public:
		ServerRep(const NetAddr &anAddr, int hostIdx);

		const NetAddr &addr() const { return theAddr; }
		int hostIdx() const { return theHostIdx; }
		int serverIdx() const { return theSrvIdx; }

		int accesses() const { return theAccCount; }

		void serverIdx(int aSrvIdx) { theSrvIdx = aSrvIdx; }

		void store(OLog &log) const;
		void load(ILog &log);

		void syncSrvInfo(const RepHdr &rep);

	protected:
		NetAddr theAddr;

		int theHostIdx;    // index into the HostMap
		int theSrvIdx;     // index into ServerRep map on Client

		int theAccCount;   // accesses to this server
};

#endif
