
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "pgl/pgl.h"

#include "xstd/String.h"
#include "pgl/PglIntSym.h"
#include "pgl/PglRec.h"
#include "pgl/PglStringSym.h"
#include "pgl/ConsoleSym.h"



String ConsoleSym::TheType = "Console";

static String strFname = "fname";
static String strVerb_lvl = "verb_lvl";


ConsoleSym::ConsoleSym(const String &aType): RecSym(aType, new PglRec) {
	theRec->bAdd(StringSym::TheType, strFname, 0);
	theRec->bAdd(IntSym::TheType, strVerb_lvl, 0);
}

ConsoleSym::ConsoleSym(const String &aType, PglRec *aRec): RecSym(aType, aRec) {
}

bool ConsoleSym::isA(const String &type) const {
	return RecSym::isA(type) ||	type == TheType;
}

SynSym *ConsoleSym::dupe(const String &type) const {
	if (isA(type))
		return new ConsoleSym(this->type(), theRec->clone());
	return RecSym::dupe(type);
}
