
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PGL_CREDENTIALS_GENERATOR_H
#define PGL_CREDENTIALS_GENERATOR_H

#include "base/StringArrayBlocks.h"

// generator of user credentials
class CredentialsGen: public StringArrayBlock {
	public:
		static String TheType;

	public:
		CredentialsGen();
		
		virtual StringArrayBlock *clone() const;

		void configure(int aCount, const String &aNamespace);

		const String &space() const { return theNamespace; };
		virtual int count() const;
		virtual bool find(const Area &member, int &idx) const;

		virtual String item(int idx) const;

	protected:
		virtual bool canMergeSameType(const StringArrayBlock &b) const;
		virtual void mergeSameType(const StringArrayBlock &b);

	protected:
		static String ThePfx;
		static char TheSfx;

		int theId;
		int theCount;
		String theNamespace;

	private:
		static int TheNextId;

		static TypeAnchor TheTypeAnchor;
};

#endif
