
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PGL_NETWORK_ADDRESS_SYMBOL_H
#define PGL_NETWORK_ADDRESS_SYMBOL_H

#include "xstd/String.h"
#include "xstd/NetAddr.h"
#include "pgl/PglRecSym.h"

class SynSymTblItem;
class StringSym;

// host:port network address

class NetAddrSym: public RecSym {
	public:
		static String TheType;

	public:
		NetAddrSym();
		NetAddrSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;

		NetAddr val() const;
		void val(const NetAddr &addr);

		String ifName() const;
		bool subnet(int &sn) const;

		void setIfname(const String &aName);
		void setSubnet(int aSubnet);

		void printUnquoted(ostream &os) const;
		virtual ostream &print(ostream &os, const String &pfx) const;

	protected:
		virtual SynSym *dupe(const String &dType) const;
};

#endif
