
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PGL_SSL_WRAP_SYMBOL_H
#define PGL_SSL_WRAP_SYMBOL_H

#include "xstd/Array.h"
#include "xstd/Size.h"
#include "pgl/PglRecSym.h"

class StrIdentifier;

// a set of addresses that talk SSL and parameters for SSL protocol
class SslWrapSym: public RecSym {
	public:
		static String TheType;

	public:
		SslWrapSym();
		SslWrapSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;

		String rootCertificate() const;
		RndDistr *protocols(const StrIdentifier &protocolNames) const;
		bool rsaKeySizes(Array<Size>&, RndDistr *&) const;
		bool ciphers(Array<String*> &, RndDistr *&) const;
		bool sessionResumpt(double &prob) const;
		bool sessionCacheSize(int &count) const;

	protected:
		virtual SynSym *dupe(const String &dType) const;
};

#endif
