
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "xstd/h/strstream.h"

#include "xml/XmlAttr.h"
#include "xml/XmlText.h"
#include "xml/XmlTable.h"


XmlTableHeading::XmlTableHeading(): XmlTableCell("th") {
}

XmlTableHeading::XmlTableHeading(const String &text, int colspan, int rowspan):
	XmlTableCell("th") {

	if (colspan != 1)
		append(XmlAttr::Int("colspan", colspan));

	if (rowspan != 1)
		append(XmlAttr::Int("rowspan", rowspan));

	append(XmlText(text));
}
