
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "xparser/xparser.h"

#include "xparser/TokenSym.h"

const String TokenSym::TheType = "Token";

TokenSym::TokenSym(const String &n, int anId): 
	SynSym(TheType), theSpell(n), theId(anId) {
}

SynSym *TokenSym::dupe(const String &type) const {
	if (type != TheType)
		return SynSym::dupe(type);
	return new TokenSym(theSpell, theId);
}

ostream &TokenSym::print(ostream &os, const String &) const {
	return os << spelling();
}
